var query_offset = 0,
    wysappend = 0,
    totalReached = false,
    searchRunning = false,
    slider = null,
    colorpicker = null;

jQuery(function($){

    // toggle advanced mode
    $('#toggle-advanced').toggle(function() {
        // advanced mode
        $(this).html(wysijatrans.hide_advanced);

        $('#advanced').show();
        $('#basic').hide();
        //$('.search-box, #results, #insert-selection').hide();
        //$('#advanced, #back-selection').show();

        initSlider();
        toggleTitlePosition();
        toggleImageWidth();
        toggleImageBlock();
        setupColorPickers();

        $(this).blur();
        return false;
    }, function() {
        // basic mode
        $(this).html(wysijatrans.show_advanced);
        // $('#advanced, #back-selection').hide();
        // $('.search-box, #results, #insert-selection').show();
        $('#basic').show();
        $('#advanced').hide();

        $(this).blur();
        return false;
    });

    $('#back-selection').click(function() {
        $('#toggle-advanced').trigger('click');
        return false;
    });

    $('#insert-selection').click(function() {
        // get selected posts and aggregate their content
        var output = '',
            post_ids = [],
            post_selection = $('#results input[name="post_selection"]:checked'),
            parameters = [],
            keys_to_encode = ['readmore', 'author_label', 'category_label'];

        // if the post selection is empty, do nothing.
        if(post_selection.length === 0) {
            return false;
        } else {
            // loop through each selected post and gather their id
            $.each(post_selection, function(i, post) {
                post_ids.push($(post).val());
            });

            // make sure to encode certain parameters
            $('#articles-form').serializeArray().each(function(pair) {
                // check if the current key needs to be encoded
                if(keys_to_encode.include(pair.name)) {
                    pair.value = window.parent.Wysija.encodeHtmlValue(pair.value);
                }

                parameters.push(pair);
            });

            wysijaAJAX.task = 'insert_articles';
            wysijaAJAX.post_ids = post_ids.join(',');
            wysijaAJAX.data = parameters;
            wysijaAJAX._wpnonce = wysijanonces.campaigns.insert_articles;

            wysijaAJAX.divider = {
                'src': window.parent.$$('.wysija_item[wysija_type="divider"]')[0].readAttribute('wysija_src'),
                'width': window.parent.$$('.wysija_item[wysija_type="divider"]')[0].readAttribute('wysija_width'),
                'height': window.parent.$$('.wysija_item[wysija_type="divider"]')[0].readAttribute('wysija_height')
            };

            // show loading
            showLoading(wysijatrans.inserting_selection);

            jQuery.ajax({
                type: 'POST',
                url: wysijaAJAX.ajaxurl,
                data: wysijaAJAX,
                success: function(response) {
                    window.parent.WysijaPopup.success(response.result.posts);
                    hideLoading();
                },
                error: ajaxArticlesError,
                dataType: 'json'
            });
        }

        return false;
    });

    // when selecting an item in the results
    $(document).on('click', '.search_results .checkbox', function() {
        if($(this).is(':checked') === true) {
            $('#post-'+ $(this).data('post-id')).addClass('selected');
        } else {
            $('#post-'+ $(this).data('post-id')).removeClass('selected');
        }
        showSelectedCount();
    });

    function showSelectedCount() {
        $('.submit-box').addClass('counting');
        var selected_count = parseInt($('.search_results .checkbox:checked').length, 10);
        if(selected_count === 0) {
            hideSelectedCount();
        } else {
            showMessage(selected_count + ' ' + wysijatrans.post_selected);
        }
    }
    function hideSelectedCount() {
        $('.submit-box').removeClass('counting');
        hideMessage();
    }

    // filters
    $(document).on('change', '#post_type', function() {
        resetSearch();
    });

    $('.post_category').change(function() {
        // reset search
        resetSearch();
    });

    $('#post_status').change(function() {
        // reset search
        resetSearch();
    });

    // search:
    $(document).on('click', '#search-submit', function() {
        triggerSearch();
        return false;
    });

    function resetSearch() {
        query_offset = 0;
        wysappend = 0;
        triggerSearch();
        return false;
    }

    function initSlider() {
        if(slider !== null) return;

        // get slider value
        var min_width = 32,
            max_width = 564,
            slider_value = Math.min(Math.max(min_width, parseInt($('#slider_info span').html())), max_width);

        // slider for image width
        slider = new Control.Slider('slider_handle', 'image_width_slider', {
          range: $R(min_width, max_width),
          slideValue: slider_value,
          axis: 'horizontal',
          onSlide: function(value) {
            var width = parseInt(value, 10);
            $('#slider_info').find('span').html(width);
            $('#image_width').val(width);
          },
          onChange: function(value) {
            var width = parseInt(value, 10);
            $('#slider_info').find('span').html(width);
            $('#image_width').val(width);
          }
        });
        slider.setValue(slider_value);
    }

    // search process
    function triggerSearch() {
        var output = '';

        if(!wysappend) {
            $("#results").html(output);
        }

        wysijaAJAX.task = 'get_articles';
        wysijaAJAX.data = $('#articles-form').serializeArray();
        wysijaAJAX.query_offset = query_offset;

        // show loading
        showLoading(wysijatrans.loading_results);
        jQuery.ajax({
            type: 'POST',
            url: wysijaAJAX.ajaxurl,
            data: wysijaAJAX,
            success: ajaxArticlesSuccess,
            error: ajaxArticlesError,
            dataType: 'json'
        });
    }

    function showLoading(message) {
        hideSelectedCount();
        $('.submit-box').addClass('loading');
        showMessage(message);
    }

    function showMessage(message) {
        if(message !== undefined) {
            $('#loading-message').html(message);
        }
    }

    function hideMessage() {
        $('#loading-message').html('');
    }

    function hideLoading() {
        $('.submit-box').removeClass('loading');
        hideMessage();
        showSelectedCount();
    }

    $('input[name="image_alignment"]').click(function() {
        toggleImageWidth();
    });

    $('input[name="post_content"]').click(function() {
        toggleTitlePosition();
        toggleImageBlock();
        toggleImageWidth();
    });

    $('input[name="title_tag"]').click(function() {
        toggleTitlePosition();
        toggleImageBlock();
        toggleImageWidth();
    });

    function toggleTitlePosition() {
        // toggle title position
        $('#title_position_block')[($('input[name="post_content"]:checked').val() === 'title') ? 'hide' : 'show']();
        // toggle title_tag list
        $('#title_tag_list')[($('input[name="post_content"]:checked').val() === 'title') ? 'show' : 'hide']();

        // check if the "advanced options" are displayed and the "show as list" for titles is hidden and if it's selected.
        if($('#advanced:visible').length > 0) {
            if($('#title_tag_list:hidden').length > 0 && $('input[name="title_tag"]:checked').val() === 'list') {
                // therefore we need to default to h2 title tag
                $('input[name="title_tag"][value="h2"]').attr('checked', 'checked');
            }
            // show/hide options depending on chosen title tag
            if($('input[name="title_tag"]:checked').val() === 'list') {
                // display titles as list
                hideOptions(['image', 'author', 'category', 'readmore', 'divider', 'bgcolor']);
            } else {
                showOptions(['image', 'author', 'category', 'readmore', 'divider', 'bgcolor']);
            }
        }
    }

    function hideOptions(options) {
        $.each(options, function(i, option) {
            $('#' + option + '-block').hide();
        });
    }

    function showOptions(options) {
        $.each(options, function(i, option) {
            $('#' + option + '-block').show();
        });
    }

    function setupColorPickers() {

        if(colorpicker !== null) return;
        colorpicker = true;

        $('input.color').modcoder_excolor({
            hue_bar : 1,
            border_color : '#969696',
            anim_speed : 'fast',
            round_corners : false,
            shadow_size : 2,
            shadow_color : '#f0f0f0',
            background_color : '#ececec',
            backlight : false,
            label_color : '#333333',
            effect : 'fade',
            show_input: false,
            z_index: 20000,
            callback_on_open: function() {
                $('html, body').animate({
                    scrollTop: $("#modcoder_colorpicker_wrapper:visible").offset().top
                }, 200);
            }
        });
    }

    function toggleImageBlock() {
        $('#image_block')[($('input[name="title_tag"][value="list"]:checked').length > 0) ? 'hide' : 'show']();
    }

    function toggleImageWidth() {
        // check alignment
        var alignment = $('input[name="image_alignment"]:checked').val(),
            is_displayed = true,
            min_width = 32,
            max_width = 325;

        if(alignment === 'center') {
            // set slider min/max width
            max_width = 564;
        } else if(alignment === 'none') {
            // disable image width
            is_displayed = false;
        }

        // toggle image width slider
        if(is_displayed === true) {
            $('#image_width_block').show();

            initSlider();
            // update slider for image width
            slider.range = $R(min_width, max_width);
            slider.setValue(slider.value);
        } else {
            $('#image_width_block').hide();
        }
    }

    function ajaxArticlesSuccess(response) {
        var output = '',
            image = null;

        if(response['result']['result']) {
            output ='<ul class="search_results">';

            $.each(response['result']['posts'], function(post_id, post) {
                // declare empty image object
                image = {
                    src: null,
                    alt: '',
                    title: ''
                };

                //post['post_title']=Base64.decode(post['post_title64']);
                if(post['post_image'] !== null) {
                    image.src = post['post_image']['src'];
                    image.alt = post['post_image']['alt'];
                    image.title = post['post_title'];
                }
                var real_post_id = query_offset + post_id;

                // build list item for post
                output += '<li id="post-'+ real_post_id +'" class="clearfix">';

                // checkbox for selection
                output += '<div class="checkbox_container">';
                output += '<input id="post-checkbox-'+ real_post_id +'" data-post-id="'+ real_post_id +'" type="checkbox" class="checkbox" value="'+ post['ID'] +'" name="post_selection" />';
                output += '</div>';

                // if there is a source image, append it to the html
                if(image.src !== null) {
                    output += '<div class="thumbnail"><img width="60" title="'+image.title+'" src="'+image.src+'" alt="'+image.alt+'" /></div>';

                    // post title as label
                    output += '<label class="with_thumbnail" for="post-checkbox-'+ real_post_id +'">' + post['post_title'] + '</label>';
                } else {
                    // post title as label
                    output += '<label for="post-checkbox-'+ real_post_id +'">' + post['post_title'] + '</label>';
                }
                output += '<span class="cpt-type">' + post['post_type'] + ' - <small>' + post['post_status'] + '</small></span>';
                output += '</li>';
            });
            output += '</ul>';
        }else{
            if(response['result']['append']) {
                output = '';
            } else {
                output = '<p class="message"><strong>'+ response['result']['msg'] +'</strong></p>';
            }
        }

        if(response['result']['append']) {
            if(output !== '') {
                $("#results").append('<hr />' + output);
            }
        }else{
            $("#results").html(output);
        }

        wysappend=0;
        searchRunning = false;

        if(parseInt(response['result']['total']) === $('ul.search_results li').length) {
            totalReached = true;
        } else {
            totalReached = false;
        }

        // hide loading
        hideLoading();

        // check if there's enough space to load more posts
        /*var results_height = parseInt($('#results').css('height'), 10),
            total_height = parseInt($('.popup_content.articles').css('height'), 10);
*/
        // if(totalReached === false && results_height < total_height) {
        //     triggerNextSearch();
        // }
        // if(totalReached === false && $('#results li').length >= 10 && results_height < total_height){
        //     triggerNextSearch();
        // }
    }

    function ajaxArticlesError(xhr, error) {
        searchRunning = false;
        wysappend = 0;
    }

    $(function() {
        // $('#toggle-advanced').trigger('click');
        triggerSearch();
    });

    $(window).scroll(function(){
        if(totalReached === false && $('#results li').length >= 10 && !wysappend && $(window).scrollTop() === ($(document).height() - $(window).height())){
           triggerNextSearch();
        }
    });
    function triggerNextSearch() {
        if($('#advanced:hidden').length === 0) return;
        if(searchRunning === true) return;
        else searchRunning = true;

        query_offset = query_offset+10;
        wysappend = 1;
        triggerSearch();
    }
});