jQuery(function($){
    // get newsletter bg color (default to white)
    var bgColor = window.parent.document.getElementById('bodyBgColorInput').value;
    if(bgColor === undefined || bgColor.length !== 6) bgColor = 'FFFFFF';

    // apply bg color to list
    $('ul.icons').css('backgroundColor', '#'+bgColor);

    // observe click event on sizes
    $(document).on('click', '.bookmarks .sizes a', function(e) {
        // deselect all sizes
        $('.bookmarks .sizes a').removeClass('selected');
        // select current size
        $(this).addClass('selected');
        // get icons for given size
        getBookmarkIcons($(this).attr('rel'), $('#bookmarks-theme').val());
        // set hidden input value
        $('#bookmarks-size').val($(this).attr('rel'));
        // set hidden input value
        $('#bookmarks-iconset').val('');
        return false;
    });

    // observe click event on icons
    $(document).on('click', '.bookmarks .icons a', function(e) {
        // deselect all icons
        $('.bookmarks .icons a').removeClass('selected');
        // select current size
        $(this).addClass('selected');
        // set hidden input value
        $('#bookmarks-iconset').val($(this).attr('rel'));
        return false;
    });

    // on submit, trigger wysija callback
    $('#bookmarks-submit').click(function() {
        // generate html
        // get icons for the selected size
        wysijaAJAX.task='generate_social_bookmarks';
        wysijaAJAX._wpnonce = wysijanonces.campaigns.generate_social_bookmarks;
        wysijaAJAX.wysijaData=$('#bookmarks-form').serializeArray();

        // ajax request to get icons
        jQuery.ajax({
            type: 'POST',
            url: wysijaAJAX.ajaxurl,
            data: wysijaAJAX,
            success: function(response) {
                if(response.result !== undefined && response.result !== '') {
                    window.parent.WysijaPopup.success(response.result);
                } else {
                    window.parent.WysijaPopup.cancel();
                }
            }
        });
        return false;
    });

    function getBookmarkIcons(size, theme) {
        // get icons for the selected size
        wysijaAJAX.task='get_social_bookmarks';
        wysijaAJAX.wysijaData={"size":size, "theme":theme};

        // ajax request to get icons
        jQuery.ajax({
            type: 'POST',
            url: wysijaAJAX.ajaxurl,
            data: wysijaAJAX,
            success: function(response) {
                if(response.result != undefined) {
                    var result = JSON.parse(response.result),
                        html = '',
                        i = 0,
                        cssClass = 'class="selected"',
                        socialNetworks;

                    // list all images for current set
                    $.each(Object.keys(result.icons).sort(), function(i, iconset) {
                        html += '<li class="clearfix"><a href="javascript:;" '+cssClass+' rel="'+iconset+'">';

                        socialNetworks = result.icons[iconset];

                        if(i == 0) {
                            cssClass = '';
                            $('#bookmarks-iconset').val(iconset);
                            i++;
                        }
                        $.each(['facebook', 'twitter', 'google', 'linkedin'], function(i, network) {
                            html += '<img src="' + socialNetworks[network] + '" alt="'+network+'" />';
                        });
                    });
                    html += '</a></li>';

                    // update icons list
                    $('ul.icons').html(html);
                }
            },
            dataType: 'json'
        });
    }

    // get icons on load
    $(function() {
        getBookmarkIcons($('#bookmarks-size').val(), $('#bookmarks-theme').val());
    });
});