jQuery(function($){

    // get newsletter bg color (default to white)
    var bgColor = window.parent.document.getElementById('bodyBgColorInput').value;
    if(bgColor == undefined || bgColor.length != 6) bgColor = 'FFFFFF';

    // apply bg color to list
    $('ul.dividers').css('backgroundColor', '#'+bgColor);

    // observe click event on icons
    $(document).on('click', '.dividers a', function(e) {
        // deselect all dividers
        $('.dividers a').removeClass('selected');
        // select current size
        $(this).addClass('selected');
        // set hidden inputs values
        var img = $(this).children(":first");
        $('#divider_src').val(img.attr('src'));
        $('#divider_width').val(img.attr('width'));
        $('#divider_height').val(img.attr('height'));
        return false;
    });

    // on submit, trigger wysija callback
    $('#dividers-submit').click(function() {
        // set params
        wysijaAJAX.task = 'set_divider';
        wysijaAJAX._wpnonce = wysijanonces.campaigns.set_divider;
        wysijaAJAX.id = $('#email_id').val();
        wysijaAJAX.wysijaData = {
            src: $('#divider_src').val(),
            width: $('#divider_width').val(),
            height: $('#divider_height').val()
        };

        // ajax request to select divider
        $.ajax({
            type: 'POST',
            url: wysijaAJAX.ajaxurl,
            data: wysijaAJAX,
            success: function(response) {
                if(response.result !== false) {
                    // update divider widget
                    window.parent.Wysija.setDivider(Base64.decode(response.result), wysijaAJAX.wysijaData);
                    // replace all dividers present
                    window.parent.Wysija.replaceDividers();
                    // refresh JS
                    window.parent.Wysija.init();
                    // trigger auto save
                    window.parent.Wysija.autoSave();
                    // close popup
                    //window.parent.tb_remove();
                    window.parent.WysijaPopup.close();
                }
            }
        });
        return false;
    });
});