var allthemes={};
displaychange=0;
jQuery(function($) {

    $(function() {
        if($('#themes-reload').length > 0) {
            // reload themes
            wysijaAJAX.task = 'refresh_themes';
            jQuery.ajax({
                type: 'POST',
                url: wysijaAJAX.ajaxurl,
                data: wysijaAJAX,
                success: function(response) {
                    // update themes list
                    window.parent.jQuery('#wj_themes_list').html(response.result.themes);
                    // trigger switchTheme on theme click
                    window.parent.handleSwitchTheme();
                    // enable delete
                    window.parent.handleRemoveTheme();
                },
                error: function(response) {
                    ;
                },
                dataType: 'json'
            });
        }
    });

    $(document).on('click', '.install', function() {
        installWysijaTheme($(this).data('id'), $(this).hasClass('installed'));
        return false;
    });

    function installWysijaTheme(themeId, isInstalled){
        wysijaAJAX.task="install_theme";
        var theme = allthemes[themeId];

        wysijaAJAX.theme_id = theme.id;
        wysijaAJAX.theme_key = theme.key;
        wysijaAJAX.premium = parseInt(theme.is_premium);
        wysijaAJAX.theme_name = theme.name;

        if(isInstalled && !confirm(wysijatrans.reinstallwarning.replace("%1$s", theme.key))) return false;

        wysijaAJAX._wpnonce=wysijanonces.campaigns.install_theme;
        jQuery('#overlay').show();
        jQuery.ajax({
            type: 'POST',
            url: wysijaAJAX.ajaxurl,
            data: wysijaAJAX,
            success: function(response) {
                WysiShow('search-view');
                jQuery('#overlay').hide();
                jQuery.WYSIJA_HANDLE_RESPONSE(response);

                // update themes list
                window.parent.jQuery('#wj_themes_list').html(response.result.themes);
                // trigger switchTheme on theme click
                window.parent.handleSwitchTheme();
                // enable delete
                window.parent.handleRemoveTheme();
            },
            error: function(response) {
                jQuery.WYSIJA_HANDLE_RESPONSE(response);
                jQuery('#overlay').hide();
                WysiShow('search-view');

            },
            dataType: 'json'
        });
    }

    function WysiShow(pan, resize) {
        $('.panel').hide();
        $('#'+pan).show();

        if(resize !== undefined && resize === true) {
            // force the popup to recalculate its dimensions
            //the setTimeout(1ms) is to make sure it's done after the content is properly loaded
            setTimeout(function() {
                window.parent.WysijaPopup.setDimensions();
            }, 1);
        }
    }

    $(document).on('click', '.infos', function() {
        var theme = allthemes[$(this).data('id')],
            extra_class = '',
            install_text = wysijatrans.install;

        if(theme === undefined) return;

        if($.inArray(theme['key'], wysijatrans.installedthemes) !== -1) {
            extra_class = ' installed';
            install_text=wysijatrans.reinstall;
        }

        if(parseInt(theme['is_premium']) === 1) {
            extra_class += ' premium';

            if(parseInt(wysijatrans.ispremium) !== 1) {
                install_text = wysijatrans.premiumonly;
            }
        }

        // theme data: preview, avatar, ...
        var preview = '<div class="theme-screenshot"><img src="'+theme.screenshot+'" alt="'+theme.name+'" /></div>';
        var avatar_author='<img src="'+get_gravatar(theme.author_email,80)+'" class="avatar" width="80px"/>';
        var details=avatar_author+'<h2>'+theme.name+'</h2><p><input type="button" value="'+install_text+'" data-id="'+theme.id+'" class="button-primary install'+extra_class+'" /></p>';

        // display average rating
        var averageRating = '<div class="stars"><div id="average-vote" class="star-rating" style="width:'+((theme.rating * 95) / 5)+'px;"></div></div>';

        // display user rating
        var userRating = '<div class="stars my-rating clearfix" data-theme="'+parseInt(theme.id)+'">';
        for(var i = 0; i < 5; i++) {
            if(parseInt(theme.user_rating) > i) {
                userRating+= '<a href="javascript:;" class="active" data-value="'+(i+1)+'"></a>';
            } else {
                userRating+= '<a href="javascript:;" data-value="'+(i+1)+'"></a>';
            }
        }
        userRating+='</div>';

        details+='<div class="paragraph"><strong>'+wysijatrans.stars.replace("%1$s",'</strong> '+wysijatrans.totalvotes.replace("%1$s",'<span id="total-votes">'+theme.votes+'</span>')+averageRating)+'</div>';
        details+='<div class="paragraph"><strong>'+wysijatrans.starsyr.replace("%1$s",'</strong>'+userRating)+'</div>';

        details+='<p><strong>'+wysijatrans.downloads.replace("%1$s",'</strong>'+theme.downloads_zip)+'</p>';
        //details+='<p><strong>'+wysijatrans.tags.replace("%1$s",'</strong>'+theme.tagslinks)+'</p>';
        details+='<p><strong>'+wysijatrans.lastupdated.replace("%1$s",'</strong>'+theme.updated_at)+'</p>';
        //details+='<p><strong>'+wysijatrans.includes.replace("%1$s",'</strong>'+theme.includedfeatures)+'</p>';
        details+='<p>'+wysijatrans.viewallthemes.replace("%1$s",'<a href="javascript:;" class="author-id-filter" id="author-id-filter'+theme.author_id+'">'+theme.author_name+'</a>')+'</p>';
        details+='<p><a href="//api.mailpoet.com/download/zip/'+theme.id+'?domain='+wysijatrans.domainname+'">'+wysijatrans.downloadzip+'</a></p>';

        // display psd download link only if the given theme has a psd file
        var psd_download_link = '';
        if(theme.has_psd == 1) {
            psd_download_link = '<p><a href="//api.mailpoet.com/download/psd/'+theme.id+'?domain='+wysijatrans.domainname+'" class="downpsd">'+wysijatrans.downloadpsd+'</a></p>';
            if(parseInt(theme['is_premium']) === 1 && parseInt(wysijatrans.ispremium) !== 1) {
                psd_download_link = '<p><strong>'+wysijatrans.premiumfiles+'</strong></p>';
            }
        }
        details+= psd_download_link;
        details+='<p><a href="'+theme.author_url+'" target="_blank">'+wysijatrans.viewauthorsite+'</a></p>';

        var themeview = '<div class="wrap actions">'+
        '<a class="button-secondary2 theme-view-back" href="javascript:;">'+wysijatrans.viewback+'</a>'+
        '</div>'+
        '<div class="theme-infos clearfix">'+
            '<div class="preview">'+preview+'</div>'+
            '<div class="infos">'+details+'</div>'+
        '</div>';

        $('#theme-view').html(themeview);

        WysiShow('theme-view', true);

        return false;
    });


    $(document).on('click', '.theme-view-back', function() {
        WysiShow('search-view', true);
        return false;
    });

    $('#gallery-form').submit(function(){
        triggerSearch();
        return false;
    });

    $(document).on('click', '.my-rating a', function() {
        var ratingtosend = parseInt($(this).data('value'));

        for(var i = 0; i < 5; i++) {
            if(i < ratingtosend) {
                $($('.my-rating a')[i]).addClass('active');
            } else {
                $($('.my-rating a')[i]).removeClass('active');
            }
        }

        var themeid = parseInt($(this).parent().data('theme'));

        $.getJSON('//api.mailpoet.com/theme/rate/'+themeid+'?rating='+ratingtosend+'&domain='+wysijatrans.domainname+'&callback=?', function(response) {
            // append themes
            if(response){
                $('#average-vote').css('width', parseInt((response.rating * 95) / 5));
                $('#total-votes').html(response.votes);
                allthemes[themeid]['votes'] = response.votes;
                allthemes[themeid]['user_rating'] = ratingtosend;
                allthemes[themeid]['rating'] = response.rating;
            }
        });
        return false;
    });

    // when user hovers the rating stars
    $(document).on('hover', '.my-rating a', function() {
        var ratingtosend = parseInt($(this).data('value'));

        $('.my-rating a').removeClass('on').removeClass('off');
        for(var i = 0; i < 5; i++) {
            if(i < ratingtosend) {
                $($('.my-rating a')[i]).addClass('on');
            } else {
                $($('.my-rating a')[i]).addClass('off');
            }
        }
    })

    // put user rating back when mouse out
    $(document).on('mouseout', '.my-rating a', function() {
        $('.my-rating a').removeClass('on').removeClass('off');
    });

    function triggerSearch(){
        loadThemes();
    }

    function ajaxThemesError(xhr, error) {
        alert("Request error not JSON:"+xhr.responseText);
        jQuery.WYSIJA_HANDLE_RESPONSE(response);
    }

    // Load themes from the Wysija search API.
    // options (type: Hash {})
    // -> author_id: get themes from a single author.
    // -> tag_id: get themes from a single tag.
    // -> is_premium: 0 (free themes) | 1 (premium themes)
    function loadThemes(options) {
        var html_output = '<li><img class="loading" title="Loading" alt="loading" src="../wp-content/plugins/wysija-newsletters/img/wpspin_light.gif" /></li>';

        $("#themes-list").html(html_output);

        // build query string
        var query_string = '';

        // check if options are passed
        if(options === undefined) {
            var options = {is_premium: 0};
        } else {
            if(options.is_premium === undefined) {
                options.is_premium = 0;
            }
        }
        // if so, convert it to a query string
        query_string = '&' + jQuery.param(options);

        // get themes
        $.getJSON('//api.mailpoet.com/theme/search?domain='+wysijatrans.domainname+query_string+'&callback=?', function(response) {
            var html_output = '';

            // append themes
            if(response) {
                // used to add specific class depending on theme's type (premium / installed) and position within the list (last item)
                var extra_class = '';

                jQuery.each(response.themes, function(iterator, theme) {

                    // populate themes array
                    allthemes[theme['id']] = theme;

                    // reset values
                    extra_class = '';

                    // set class for the last theme of each row
                    if((iterator + 1) % 5 === 0) {
                        extra_class += ' last';
                    }

                    //if is installed already, we need to flag it
                    var install_text = wysijatrans.install;
                    if(jQuery.inArray(theme['key'], wysijatrans.installedthemes) !== -1) {
                        extra_class += ' installed';
                        install_text = wysijatrans.reinstall;
                    }

                    if(parseInt(theme['is_premium']) === 1) {
                        extra_class += ' premium';

                        if(parseInt(wysijatrans.ispremium) !== 1) {
                            install_text = wysijatrans.premiumonly;
                        }
                    }

                    html_output += '<li class="theme'+extra_class+'">';
                        html_output += '<div class="thumbnail">';
                            html_output += '<img src="'+theme['thumbnail_large']+'" alt="'+theme['name']+'" title="'+theme['name']+'" />'
                            html_output += '<a class="button-primary install'+extra_class+'" href="javascript:;" data-id="'+theme['id']+'">'+install_text+'</a>';
                        html_output +='</div>';
                        html_output += '<a class="infos" href="javascript:;" data-id="'+theme['id']+'">'+wysijatrans.viewinfos+'</a>';
                    html_output += '</li>';
                });
            } else {
                var html_output = '<div>';
                html_output += '<strong>'+wysijatrans.errorconnecting+'</strong>';
                html_output += '</div>';
            }

            $("#themes-list").html(html_output);
        });
    }

    $('#sub-theme-box').click(function(){
        WysiShow('theme-upload', true);
    });

    $(document).on('click', 'a.author-id-filter', function() {
        $('#filter-selection').html('<a href="javascript:;" class="button-secondary2 filter-none">'+wysijatrans.showallthemes+'</a>');
        // this needs to be improved, use data-id instead!!!
        loadThemes({
            author_id: parseInt($(this).attr('id').replace('author-id-filter', ''))
        });
        WysiShow('search-view', true);
        return false;
    });

    $(document).on('click', 'a.filter-none', function() {
        // reset filters
        $('#filter-selection').html('');
        loadThemes();
        return false;
    });

    // Handle the free or premium filter requests.
    $('#wj_paginator').on('click', 'a', function() {
        // reset filters
        $('#filter-selection').html('');

        // if the link is already selected, we do not need to reload the themes
        if($(this).hasClass('selected')) {
            return false;
        }

        // otherwise, load themes depending on the type (either free or premium)
        loadThemes({is_premium: (($(this).data('type') === 'premium') ? 1 : 0) });

        // remove the selected class from all links and set the clicked link as selected
        $('#wj_paginator a').removeClass('selected');
        $(this).addClass('selected');

        return false;
    });

    // On first load, show only free themes.
    loadThemes();

    function get_gravatar(email, size) {
        if(email==null){
            return 'http://www.gravatar.com/avatar/ad516503a11cd5ca435acc9bb6523536?s='+size;
        }
        // MD5 (Message-Digest Algorithm) by WebToolkit
        // http://www.webtoolkit.info/javascript-md5.html

        var MD5=function(s){function L(k,d){return(k<<d)|(k>>>(32-d))}function K(G,k){var I,d,F,H,x;F=(G&2147483648);H=(k&2147483648);I=(G&1073741824);d=(k&1073741824);x=(G&1073741823)+(k&1073741823);if(I&d){return(x^2147483648^F^H)}if(I|d){if(x&1073741824){return(x^3221225472^F^H)}else{return(x^1073741824^F^H)}}else{return(x^F^H)}}function r(d,F,k){return(d&F)|((~d)&k)}function q(d,F,k){return(d&k)|(F&(~k))}function p(d,F,k){return(d^F^k)}function n(d,F,k){return(F^(d|(~k)))}function u(G,F,aa,Z,k,H,I){G=K(G,K(K(r(F,aa,Z),k),I));return K(L(G,H),F)}function f(G,F,aa,Z,k,H,I){G=K(G,K(K(q(F,aa,Z),k),I));return K(L(G,H),F)}function D(G,F,aa,Z,k,H,I){G=K(G,K(K(p(F,aa,Z),k),I));return K(L(G,H),F)}function t(G,F,aa,Z,k,H,I){G=K(G,K(K(n(F,aa,Z),k),I));return K(L(G,H),F)}function e(G){var Z;var F=G.length;var x=F+8;var k=(x-(x%64))/64;var I=(k+1)*16;var aa=Array(I-1);var d=0;var H=0;while(H<F){Z=(H-(H%4))/4;d=(H%4)*8;aa[Z]=(aa[Z]|(G.charCodeAt(H)<<d));H++}Z=(H-(H%4))/4;d=(H%4)*8;aa[Z]=aa[Z]|(128<<d);aa[I-2]=F<<3;aa[I-1]=F>>>29;return aa}function B(x){var k="",F="",G,d;for(d=0;d<=3;d++){G=(x>>>(d*8))&255;F="0"+G.toString(16);k=k+F.substr(F.length-2,2)}return k}function J(k){k=k.replace(/rn/g,"n");var d="";for(var F=0;F<k.length;F++){var x=k.charCodeAt(F);if(x<128){d+=String.fromCharCode(x)}else{if((x>127)&&(x<2048)){d+=String.fromCharCode((x>>6)|192);d+=String.fromCharCode((x&63)|128)}else{d+=String.fromCharCode((x>>12)|224);d+=String.fromCharCode(((x>>6)&63)|128);d+=String.fromCharCode((x&63)|128)}}}return d}var C=Array();var P,h,E,v,g,Y,X,W,V;var S=7,Q=12,N=17,M=22;var A=5,z=9,y=14,w=20;var o=4,m=11,l=16,j=23;var U=6,T=10,R=15,O=21;s=J(s);C=e(s);Y=1732584193;X=4023233417;W=2562383102;V=271733878;for(P=0;P<C.length;P+=16){h=Y;E=X;v=W;g=V;Y=u(Y,X,W,V,C[P+0],S,3614090360);V=u(V,Y,X,W,C[P+1],Q,3905402710);W=u(W,V,Y,X,C[P+2],N,606105819);X=u(X,W,V,Y,C[P+3],M,3250441966);Y=u(Y,X,W,V,C[P+4],S,4118548399);V=u(V,Y,X,W,C[P+5],Q,1200080426);W=u(W,V,Y,X,C[P+6],N,2821735955);X=u(X,W,V,Y,C[P+7],M,4249261313);Y=u(Y,X,W,V,C[P+8],S,1770035416);V=u(V,Y,X,W,C[P+9],Q,2336552879);W=u(W,V,Y,X,C[P+10],N,4294925233);X=u(X,W,V,Y,C[P+11],M,2304563134);Y=u(Y,X,W,V,C[P+12],S,1804603682);V=u(V,Y,X,W,C[P+13],Q,4254626195);W=u(W,V,Y,X,C[P+14],N,2792965006);X=u(X,W,V,Y,C[P+15],M,1236535329);Y=f(Y,X,W,V,C[P+1],A,4129170786);V=f(V,Y,X,W,C[P+6],z,3225465664);W=f(W,V,Y,X,C[P+11],y,643717713);X=f(X,W,V,Y,C[P+0],w,3921069994);Y=f(Y,X,W,V,C[P+5],A,3593408605);V=f(V,Y,X,W,C[P+10],z,38016083);W=f(W,V,Y,X,C[P+15],y,3634488961);X=f(X,W,V,Y,C[P+4],w,3889429448);Y=f(Y,X,W,V,C[P+9],A,568446438);V=f(V,Y,X,W,C[P+14],z,3275163606);W=f(W,V,Y,X,C[P+3],y,4107603335);X=f(X,W,V,Y,C[P+8],w,1163531501);Y=f(Y,X,W,V,C[P+13],A,2850285829);V=f(V,Y,X,W,C[P+2],z,4243563512);W=f(W,V,Y,X,C[P+7],y,1735328473);X=f(X,W,V,Y,C[P+12],w,2368359562);Y=D(Y,X,W,V,C[P+5],o,4294588738);V=D(V,Y,X,W,C[P+8],m,2272392833);W=D(W,V,Y,X,C[P+11],l,1839030562);X=D(X,W,V,Y,C[P+14],j,4259657740);Y=D(Y,X,W,V,C[P+1],o,2763975236);V=D(V,Y,X,W,C[P+4],m,1272893353);W=D(W,V,Y,X,C[P+7],l,4139469664);X=D(X,W,V,Y,C[P+10],j,3200236656);Y=D(Y,X,W,V,C[P+13],o,681279174);V=D(V,Y,X,W,C[P+0],m,3936430074);W=D(W,V,Y,X,C[P+3],l,3572445317);X=D(X,W,V,Y,C[P+6],j,76029189);Y=D(Y,X,W,V,C[P+9],o,3654602809);V=D(V,Y,X,W,C[P+12],m,3873151461);W=D(W,V,Y,X,C[P+15],l,530742520);X=D(X,W,V,Y,C[P+2],j,3299628645);Y=t(Y,X,W,V,C[P+0],U,4096336452);V=t(V,Y,X,W,C[P+7],T,1126891415);W=t(W,V,Y,X,C[P+14],R,2878612391);X=t(X,W,V,Y,C[P+5],O,4237533241);Y=t(Y,X,W,V,C[P+12],U,1700485571);V=t(V,Y,X,W,C[P+3],T,2399980690);W=t(W,V,Y,X,C[P+10],R,4293915773);X=t(X,W,V,Y,C[P+1],O,2240044497);Y=t(Y,X,W,V,C[P+8],U,1873313359);V=t(V,Y,X,W,C[P+15],T,4264355552);W=t(W,V,Y,X,C[P+6],R,2734768916);X=t(X,W,V,Y,C[P+13],O,1309151649);Y=t(Y,X,W,V,C[P+4],U,4149444226);V=t(V,Y,X,W,C[P+11],T,3174756917);W=t(W,V,Y,X,C[P+2],R,718787259);X=t(X,W,V,Y,C[P+9],O,3951481745);Y=K(Y,h);X=K(X,E);W=K(W,v);V=K(V,g)}var i=B(Y)+B(X)+B(W)+B(V);return i.toLowerCase()};

        var size = size || 80;

        return 'http://www.gravatar.com/avatar/' + MD5(email) + '.jpg?s=' + size;
    }
});