/*jshint strict: true */
/*jslint nomen: true */
/*global jQuery, document, _ */

(function ($, _) {
    'use strict';

    $(document).ready(function () {
        var $selects = $('.mp-select-sort').on({
            'sort': function(){
                var $select = $(this).each(function (k, el) {
                        var $el = $(el),
                            $opts = $el.children('option');

                        $opts.detach().sort(function (a, b) {
                            // To avoid some option to be sorted just add a data-sort="0" to the select
                            if ( parseInt( $(a).data('sort'), 10 ) === 0 || parseInt( $(b).data('skip'), 10 ) === 0 ){
                                return 0;
                            }
                            if (a.innerHTML === 'NA') {
                                return 1;
                            } else if (b.innerHTML === 'NA') {
                                return -1;
                            }
                            return (a.innerHTML.toLowerCase() > b.innerHTML.toLowerCase()) ? 1 : -1;
                        }).appendTo($el);

                        // When on Gecko Browsers you will hit a bug for sorting Options, the selected will be the last
                        // one that is listed instead of the one with the selected attr, so you prop the first one to
                        // be true to be able to see the correct.
                        $opts.filter( '[selected]' ).eq( 0 ).prop( 'selected', true );
                    });
            }
        }).trigger( 'sort' );
    });

}(jQuery.noConflict(), _));