
function StatsFilter (options) {
	this.forceToSortByDesc = typeof options.forceToSortByDesc !== 'undefined' ?  options.forceToSortByDesc : false;
	/**
     * list of blocks/modules in which we allows to sort by 2 directions, ASC or DESC
     * @type Array
     */
	this.sortBy2Directions = ['stats_top_domains'];
	this.from = typeof options.from !== 'undefined' ? options.from : null;
	this.to = typeof options.to !== 'undefined' ? options.to : null;
	this.lastDays = typeof options.lastDays !== 'undefined' ? options.lastDays : null;
	this.formName = typeof options.formName !== 'undefined' ? options.formName : null;
	this.block = typeof options.block !== 'undefined' ? options.block : null;
	this.itemPerPage = typeof options.itemPerPage !== 'undefined' ? options.itemPerPage : null;
	this.orderDirection = typeof options.sortDirection !== 'undefined' ? options.sortDirection : 'DESC';
	this.orderBy = typeof options.sortBy !== 'undefined' ? options.sortBy : null;

	this.isInProgress = false;

	this.submit = function(e, lazyLoad) {
		e.preventDefault();
		if (this.isInProgress) {
			wysijaLazyLoad.terminate();
		}
		this.moduleName = null;
		this.itemPerPage = null;
		this.setupLazyLoad(lazyLoad);
		return false;
	};

	this.doFilter = function(target, lazyLoad){
		if (this.isInProgress) {
			wysijaLazyLoad.terminate();
		}
		this.isInProgress = true;
		forceToSortByDesc = this.forceToSortByDesc;
		if (forceToSortByDesc && this.sortBy2Directions.indexOf(this.block) !== -1)
			forceToSortByDesc = false;
		blocks = this.block.split(' ');

		wysijaLazyLoad.options.data = [blocks[0]];
		wysijaLazyLoad.options.task = lazyLoad.task;
		wysijaLazyLoad.options.filter = {
			from: this.from,
			to: this.to,
			lastDays: this.lastDays,
			itemPerPage: this.itemPerPage,
			orderBy : this.orderBy,
			orderDirection : forceToSortByDesc ? 'DESC' : this.orderDirection
		};
		if (typeof blocks[1] !== 'undefined') {
			jQuery.extend(wysijaLazyLoad.options.filter, {
				additionalParam : blocks[1]
			});
		}
		wysijaLazyLoad.init(function(response){
			var parentElement;
			prevElement = jQuery(target).prev();
			if (prevElement.length === 0) // if this is the first element
				parentElement = jQuery(target).parent();
			jQuery(target).fadeOut(400,function(){
				jQuery(this).remove();
				if (typeof parentElement !== 'undefined')
					jQuery(parentElement).prepend(response.result);
				else
					jQuery(response.result).insertAfter(prevElement);
			});
			StatsFilter.instance.isInProgress = false;
		});
	};

	this.setupLazyLoad = function(lazyLoad) {
		var blocks = jQuery.extend([],wysijaStatisticVars.lazyLoad.blocks);
		if (blocks.length <= 0) return;

		this.isInProgress = true;
		wysijaLazyLoad.options.data = blocks;
		wysijaLazyLoad.options.task = lazyLoad.task;
		wysijaLazyLoad.options.filter = {
			from: this.from,
			to: this.to,
			lastDays: this.lastDays
		};
		jQuery(lazyLoad.targetContainer).empty();
		wysijaLazyLoad.init(function(response, penddingBlock){
			if (typeof penddingBlock !== 'undefined' && penddingBlock === 0) {
				StatsFilter.instance.isInProgress = false;
			}
			jQuery(lazyLoad.targetContainer).append(response.result);
		});
	};

	this.fromChange = function(e) {
		this.from = e.target.value;
	};

	this.toChange = function(e) {
		this.to = e.target.value;
	};

	this.lastDaysChange = function(newValue) {
		this.lastDays = newValue;
	}

	this.formValidate = function() {
		return true;
	};

	StatsFilter.instance = this;
	return this;
}