
jQuery(function($){
	/**
     * Setup lazy load process - loading block by block
     * @param {type} targetContainer
     * @param {type} blocks
     * @param {type} task
     * @todo: convert to class, implement design pattern Observer . Merge with admin-statistics-filter.js
     */
	var setupLazyLoad = function(targetContainer, blocks, task){
		if (typeof wysijaLazyLoad === 'undefined'){
			return;
		}
		StatsFilter.instance.isInProgress = true;
		wysijaLazyLoad.options.data = blocks;
		wysijaLazyLoad.options.task = task;
		wysijaLazyLoad.options.filter = {
			from: $('#stats-filter-from').val(),
			to: $('#stats-filter-to').val(),
			lastDays: $('#custom-date').val()
		};
		wysijaLazyLoad.init(function(response, penddingBlock){
			penddingBlock;
			if (penddingBlock === 0) {
				StatsFilter.instance.isInProgress = false;
			}
			jQuery(targetContainer).append(response.result);
		});
	};

	var setupFilter = function() {
		var statsFilter = new StatsFilter({
			from: $('#stats-filter-from').val(),
			to: $('#stats-filter-to').val(),
			lastDays: $('#custom-date').val(),
			formName: 'stats-filter',
			forceToSortByDesc: true
		});
		var isCustomDate = false;
		$('#stats-filter-from').change(function(e){
			if (!isCustomDate)
			{
				$('#custom-date').val(0);
				statsFilter.lastDaysChange($('#custom-date').val());
			}
			statsFilter.fromChange(e);
		});
		$('#stats-filter-to').change(function(e){
			if (!isCustomDate)
			{
				$('#custom-date').val(0);
				statsFilter.lastDaysChange($('#custom-date').val());
			}
			statsFilter.toChange(e);
		});
		$('#custom-date').change(function(e){
			isCustomDate = true;
			$('#stats-filter-from').val($(e.target.options[e.target.selectedIndex]).attr('from')).change();
			$('#stats-filter-to').val($(e.target.options[e.target.selectedIndex]).attr('to')).change();
			statsFilter.lastDaysChange(e.target.value);
			isCustomDate = false;// reset
			if (e.target.value != '0') {
				$('#stats-filter').submit();
			}
		});
		$('#stats-filter').submit(function(e){
			statsFilter.submit(e, wysijaStatisticVars.lazyLoad);
		});

		$(document).on('click', '.sort-filter', function(e) {
			var orderDirection = ($(this).hasClass('asc') ? 'asc' : 'desc');
			orderDirection = (orderDirection === 'desc' ? 'asc' : 'desc');
			$(this).removeClass('desc').removeClass('asc').addClass(orderDirection);
			statsFilter.orderDirection = orderDirection;
			statsFilter.orderBy = $(this).attr('rel');
			statsFilter.block = $(this).parents('.container').attr('rel');
			statsFilter.doFilter($(this).parents('.container'), wysijaStatisticVars.lazyLoad);
		});

		/**
	 * It is strange when the first block is not binded event "click".
	 */
		$('.page-limit').click(function(){
			statsFilter.itemPerPage = parseInt($(this).html());
			statsFilter.block = $(this).parents('.container').attr('rel');
			statsFilter.doFilter($(this).parents('.container'), wysijaStatisticVars.lazyLoad);
		});

		$(document).on('click', '.page-limit', function(e) {
			statsFilter.itemPerPage = parseInt($(this).html());
			statsFilter.block = $(this).parents('.container').attr('rel');
			statsFilter.doFilter($(this).parents('.container'), wysijaStatisticVars.lazyLoad);
		});
	};

	setupFilter();
	$(wysijaStatisticVars.filter.datePickerElements).datepicker({
		dateFormat: wysijaStatisticVars.filter.dateFormat
	});
	if (wysijaStatisticVars.lazyLoad){
		var _blocks = jQuery.extend([],wysijaStatisticVars.lazyLoad.lazyLoadBlocks);
		setupLazyLoad(wysijaStatisticVars.lazyLoad.targetContainer, _blocks, wysijaStatisticVars.lazyLoad.task);
	}
});
