var tinymceConfig = {
    mode : 'specific_textareas',
    theme : 'advanced',
    width : '100%',
    skin : 'wp_theme',
    directionality: ((isRtl) ? 'rtl' : 'ltr'),
    theme_advanced_buttons1 : "bold, italic, bullist, wysija_custom_fields, link, unlink, forecolor",
    theme_advanced_buttons2 : "justifyleft, justifycenter, justifyright, formatselect",
    theme_advanced_buttons3 : "",
    theme_advanced_buttons4 : "",
    theme_advanced_toolbar_location : "top",
    theme_advanced_toolbar_align : "left",
    theme_advanced_statusbar_location : "none",
    theme_advanced_path : false,
    theme_advanced_blockformats : 'p,h1,h2,h3',
    formats : {
        alignleft : [
            {selector : 'img,h1,h2,h3,p,ul,li', classes : 'align-left'}
        ],
        aligncenter : [
            {selector : 'img,h1,h2,h3,p,ul,li', classes : 'align-center'}
        ],
        alignright : [
            {selector : 'img,h1,h2,h3,p,ul,li', classes : 'align-right'}
        ],
        alignfull: [
            {selector : 'img,h1,h2,h3,p,ul,li', classes : 'align-justify'}
        ],
        strikethrough : {inline : 'del'}
    },
    forced_root_block : 'p',
    force_br_newlines : true,
    autoresize_min_height: 30,
    autoresize_bottom_margin: 40,
    autoresize_on_init: true,
    relative_urls : false,
    remove_script_host : false,
    convert_urls : false,
    apply_source_formatting : false,
    remove_linebreaks : false,
    gecko_spellcheck : true,
    keep_styles : false,
    entities : "38,amp,60,lt,62,gt",
    accessibility_focus : true,
    media_strict: false,
    dialog_type: "modal",
    plugins: "inlinepopups,paste,wysija_custom_fields,autoresize",
    paste_convert_headers_to_strong : false,
    valid_elements: "p[class],span[class|style],a[href|class|title|target],h1[class],h2[class],h3[class],ul[class],li[class],strong[class],em[class],strike,br",
    invalid_elements: "script",
    init_instance_callback : "Wysija.setTextStyles",
    cleanup_callback : "Wysija.editorCleanup"
};

// toggle html source code
if(typeof Wysija_i18n !== 'undefined' && parseInt(Wysija_i18n.html_source_enabled) === 1) {
    tinymceConfig.theme_advanced_buttons2 += ', code';
    tinymceConfig.valid_elements = '';
}

var tinyMCEPreInit = {
    mceInit : tinymceConfig
};
tinyMCE.init(tinyMCEPreInit.mceInit);