/**
 * class wysijaLazyLoad, setup/manage lazy loading process
 * Depends:
 *	wysijaAJAX
 */
var wysijaLazyLoad = {};
wysijaLazyLoad.options = {
	data: [],
	task: null,
	successCallback: null,
	errorCallback: null,
	targetContainer: null,
	filter:null,
	spinner:'.spinner'
};

/**
 * current object request
 * @type jqXHR
 */
wysijaLazyLoad.jqXHR = null;
wysijaLazyLoad.init = function(successCallback, errorCallback){
	options = wysijaLazyLoad.options;
	if (typeof options.data === 'undefined' || typeof options.task === 'undefined')
		return;
	if (!jQuery.isArray(options.data))
		return;
	if (typeof options.filter !== 'undefined' && options.filter !== null)
		wysijaAJAX.filter = options.filter;
	wysijaAJAX.task = options.task;
	blockNames = wysijaLazyLoad.options.data.splice(0,1);

	if (parseInt(blockNames.length) > 0)
	{
		wysijaAJAX.block = blockNames[0];
		wysijaLazyLoad.lazyLoad(successCallback, errorCallback, function(){

			});
	}
};
wysijaLazyLoad.lazyLoad = function(successCallback){
	wysijaLazyLoad.jqXHR = jQuery.ajax({
		type: 'POST',
		url: wysijaAJAX.ajaxurl,
		data: wysijaAJAX,
		dataType: 'json',
		beforeSend: function(){
			jQuery(wysijaLazyLoad.options.spinner).show();
		},
		success: function(response){
			blockNames = wysijaLazyLoad.options.data.splice(0,1);
			if (parseInt(blockNames.length) > 0)
			{
				wysijaAJAX.block = blockNames[0];
				wysijaLazyLoad.lazyLoad(successCallback);
			}
			else
			{
				jQuery(wysijaLazyLoad.options.spinner).hide();
			}
			successCallback(response, parseInt(blockNames.length));

		},
		error: function(response){
			blockNames = wysijaLazyLoad.options.data.splice(0,1);
			if (parseInt(blockNames.length) > 0)
			{
				wysijaAJAX.block = blockNames[0];
				wysijaLazyLoad.lazyLoad(successCallback);
			}
		}
	});
};

/**
 * Stop all opening ajax requests
 * @returns {undefined}
 */
wysijaLazyLoad.terminate = function() {
	try {
		wysijaLazyLoad.options.data = new Array();
		wysijaLazyLoad.jqXHR.abort();
	} catch (e){};
};
